diff -r 3f1e7d35d0ab -r 821e8eadeaff src/dep/time.c
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/dep/time.c	Sun Oct 27 22:49:29 2013 -0700
@@ -0,0 +1,1208 @@
+/*-
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2011-2012 Solarflare Communications Inc
+ *
+ * All Rights Reserved
+ * 
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are
+ * met:
+ * 1. Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ * DISCLAIMED. IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
+ * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+ * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
+ * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
+ * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include "../ptpd.h"
+#include <stdarg.h>
+#include <math.h>
+
+#ifdef __sun
+#include <unistd.h>
+#include <stropts.h>
+#endif
+
+
+#ifdef linux
+
+#include <asm/types.h>
+#include <linux/errqueue.h>
+
+/* SO_EE_ORIGIN_TIMESTAMPING is defined in linux/errqueue.h in recent kernels.
+ * Define it for compilation with older kernels.
+ */
+#ifndef SO_EE_ORIGIN_TIMESTAMPING
+#define SO_EE_ORIGIN_TIMESTAMPING 4
+#endif
+
+/* SO_TIMESTAMPING is defined in asm/socket.h in recent kernels.
+ * Define it for compilation with older kernels.
+ */
+#ifndef SO_TIMESTAMPING
+#define SO_TIMESTAMPING  37
+#define SCM_TIMESTAMPING SO_TIMESTAMPING
+#endif
+
+/* SIOCSHWTSTAMP is defined in linux/sockios.h in recent kernels.
+ * Define it for compilation with older kernels.
+ */
+#ifndef SIOCSHWTSTAMP
+#define SIOCSHWTSTAMP 0x89b0
+#endif
+
+#endif /*linux*/
+
+/* SO_TIMESTAMPING gets an integer bit field comprised of these values */
+enum {
+	SOF_TIMESTAMPING_TX_HARDWARE = (1<<0),
+	SOF_TIMESTAMPING_TX_SOFTWARE = (1<<1),
+	SOF_TIMESTAMPING_RX_HARDWARE = (1<<2),
+	SOF_TIMESTAMPING_RX_SOFTWARE = (1<<3),
+	SOF_TIMESTAMPING_SOFTWARE = (1<<4),
+	SOF_TIMESTAMPING_SYS_HARDWARE = (1<<5),
+	SOF_TIMESTAMPING_RAW_HARDWARE = (1<<6),
+	SOF_TIMESTAMPING_MASK =
+	(SOF_TIMESTAMPING_RAW_HARDWARE - 1) |
+	SOF_TIMESTAMPING_RAW_HARDWARE
+};
+
+#ifdef __sun
+#include "sfxge_ioctl.h"
+#else 
+#include "efx_ioctl.h"
+#endif
+
+/** global state for controlling system time when TIME_BOTH is selected */
+static PtpClock timeBothClock;
+PtpClock *G_timeBothClock = NULL;
+
+/** run time optsions for controlling system time when TIME_BOTH is selected */
+static  RunTimeOpts timeBothRtOpts;
+RunTimeOpts *G_timeBothRtOpts = NULL;
+
+/**
+ * Most recent send time stamp from NIC, 0/0 if none available right now.
+ * Reset by getSendTime().
+ */
+static TimeInternal lastSendTime;
+
+#ifndef RECV_ARRAY_SIZE
+/**
+ * Must be large enough to buffer all time stamps received from the NIC
+ * but not yet requested by the protocol processor. Because new information
+ * can only be added when the protocol asks for old one, this should not
+ * get very full.
+ */
+# define RECV_ARRAY_SIZE 10
+#endif
+
+/**
+ * An array of the latest RECV_ARRAY_SIZE packet receive information.
+ * Once it overflows the oldest ones are overwritten in a round-robin
+ * fashion.
+ */
+static struct {
+  TimeInternal recvTimeStamp;
+  UInteger16 sequenceId;
+  ClockIdentity clockId;
+} lastRecvTimes[RECV_ARRAY_SIZE];
+
+/**
+ * Oldest valid and next free entry in lastRecvTimes.
+ * Valid ones are [oldest, free[ if oldest <= free,
+ * otherwise [oldest, RECV_ARRAY_SIZE[ and [0, free[.
+ */
+static int oldestRecv, nextFreeRecv;
+
+int ptp_ioctl(NetPath *netPath, void *drv_ioctl)
+{
+#ifndef __sun
+	netPath.eventSockIFR.ifr_data = drv_ioctl;
+	return(ioctl(netPath->eventSock, SIOCEFX, &netPath->eventSockIFR));
+#else	/* __sun */
+	struct strioctl ioc;
+	struct sfxge_sock_ioctl *req = (struct sfxge_sock_ioctl *)drv_ioctl;
+	int len;
+
+	switch(req->cmd) {
+		case SFXGE_TS_INIT:
+			len = sizeof (struct sfxge_hwtstamp_config);
+			DBGV("SFXGE_TS_INIT issued\n");
+			break;
+		case SFXGE_TS_READ:
+			len = sizeof (struct sfxge_ts_read);
+			DBGV("SFXGE_TS_READ issued\n");
+			break;
+		case SFXGE_TS_ADJTIME:
+			len = sizeof (struct sfxge_ts_adjtime);
+			DBGV("SFXGE_TS_ADJTIME issued\n");
+			break;
+		case SFXGE_TS_SETTIME:
+			len = sizeof (struct sfxge_ts_settime);
+			DBGV("SFXGE_TS_SETTIME issued\n");
+			break;
+		case SFXGE_TS_SYNC:
+			len = sizeof (struct sfxge_ts_sync);
+			DBGV("SFXGE_TS_SYNC issued\n");
+			break;
+		default:
+			printf("Unknown ioctl number %x ... exiting\n", req->cmd);
+			exit (1);
+	}
+	(void) memset(&ioc, 0, sizeof (ioc));
+	ioc.ic_cmd = req->cmd;
+	ioc.ic_timout = 0;
+	ioc.ic_len = len;
+	ioc.ic_dp = (char *)&req->u;
+	return (ioctl(netPath->devFd, I_STR, (char *)&ioc));
+#endif	/* __sun */
+}
+/**
+ * if TIME_BOTH: measure NIC<->system time offsets and adapt system time
+ *
+ * This function is called whenever init.c gets control; to prevent to
+ * frequent changes it ignores invocations less than one second away from
+ * the previous one.
+ */
+void syncSystemWithNIC(RunTimeOpts *rtOpts, PtpClock *ptpClock)
+{
+  TimeInternal delay;
+  static TimeInternal zero;
+#ifdef __sun
+  struct sfxge_sock_ioctl req;
+#else
+  struct efx_sock_ioctl req;
+#endif
+
+  if(rtOpts->time_mode != TIME_BOTH)
+    return;
+
+  /* Limit the number of times per second we synchronise with the NIC */
+  static TimeInternal lastsync;
+  TimeInternal now, t;
+  LongDouble offset;
+  timerNow(&now);
+  subTime(&t, &now, &lastsync);
+  offset = (LongDouble)t.seconds + ((LongDouble)t.nanoseconds / 1000000000);
+  if ((offset > 0) && (offset < rtOpts->system_time_update_interval))
+    return;
+
+  lastsync = now;
+
+  memset(&req, 0, sizeof(req));
+#if  defined(__sun)
+  req.cmd = SFXGE_TS_SYNC;
+#else
+  req.cmd = EFX_TS_SYNC;
+#endif
+  if (ptp_ioctl(&ptpClock->netPath, &req) < 0) {
+    ptpClock->statistics.ts_sync_failures++;
+    ERROR("failed to correlate SFC NIC and system clock %d times (if %s, error %s)\n",
+          ptpClock->statistics.ts_sync_failures,
+          ptpClock->netPath.eventSockIFR.lifr_name, strerror(errno));
+    return;
+  }
+
+  /* For master modes, set the name according to the port state */
+  switch (rtOpts->master_slave_mode) {
+    case PTP_MODE_MASTER_WITH_NTP:
+      if (ptpClock->portState == PTP_MASTER) {
+        ptpClock->name = "[nic->slave]";
+      } else if (ptpClock->portState == PTP_PASSIVE) {
+        ptpClock->name = "[master||nic]";
+      }
+      break;
+      
+    case PTP_MODE_MASTER_NO_NTP:
+      if (ptpClock->portState == PTP_MASTER) {
+        ptpClock->name = "[nic->slave]";
+      } else if (ptpClock->portState == PTP_SLAVE) {
+        ptpClock->name = "[master->nic]";
+      }
+      break;
+      
+    default:
+      /* Do nothing */
+      break;
+  }
+
+  /* Update the timeBothClock with leap seconds in progress from main servo 
+   * to make sure we don't try to update the system clock during the leap
+   * second.
+   */
+  timeBothClock.leapSecondInProgress = ptpClock->leapSecondInProgress;
+
+  // TODO Possibly the delay req time needs to be inverted or doubled
+  // We don't really support a measurement of the one way delay at present.
+
+  DBGV("sync value %lld.%09d\n", req.u.ts_sync.ts.tv_sec, req.u.ts_sync.ts.tv_nsec);
+  delay.seconds = req.u.ts_sync.ts.tv_sec;
+  delay.nanoseconds = req.u.ts_sync.ts.tv_nsec;
+  DBGV("system to NIC delay %ld.%09d\n", delay.seconds, delay.nanoseconds);
+
+  timeBothClock.delay_req_receive_time = delay;
+  timeBothClock.delay_req_send_time = zero;
+  /* Note- we don't use the correction factor- zero */
+  updateDelay(&timeBothClock.owd_filt, &timeBothRtOpts, &timeBothClock, &zero);
+
+  /* Note that the NIC to system delay and system to NIC delay are the same */
+  DBGV("NIC to system delay %ld.%09d\n", delay.seconds, delay.nanoseconds);
+  /* Note that we don't use the correction factor - zero */
+  updateOffset(&delay, &zero, &timeBothClock.ofm_filt, &timeBothRtOpts, &timeBothClock, &zero);
+
+  updateClock(&timeBothRtOpts, &timeBothClock);
+  DBGV("system time updated\n");
+}
+
+static Boolean selectNICTimeMode(TimeMode timeMode, PtpClock *ptpClock)
+{
+  NetPath *netPath = &ptpClock->netPath;
+
+  DBGV("time stamp rx/tx packets\n");
+
+#ifdef linux
+  /* Linux SW mode is an anomaly and we treat it differently to the other modes */
+  if (timeMode == TIME_SYSTEM_LINUX_SW) {
+    /* same as before, but without requiring support by the NIC */
+    int so_timestamping_flags = SOF_TIMESTAMPING_TX_SOFTWARE
+                              | SOF_TIMESTAMPING_RX_SOFTWARE
+                              | SOF_TIMESTAMPING_SOFTWARE;
+
+    if (setsockopt(netPath->eventSock, SOL_SOCKET, SO_TIMESTAMPING,
+                   &so_timestamping_flags, sizeof(so_timestamping_flags)) < 0) {
+      ERROR("SO_TIMESTAMPING: setsockopt error: %s", strerror(errno));
+      return FALSE;
+    }
+
+    NOTIFY("SO_TIMESTAMPING (software) enabled\n");
+    ptpClock->tsMethod = TS_METHOD_SO_TIMESTAMPING;
+    return TRUE;
+  }
+#endif
+
+  /* For the modes linux_hw, nic and both, try to enable SO_TIMESTAMPING. If
+   * that fails, attempt IOCTL based timestamping. Otherwise, fail.
+   */
+
+#ifndef __sun /* Do not attempt to compile for the time being if on __sun */
+
+  /* Attempt SO_TIMSTAMPING */
+  NOTIFY("trying SO_TIMESTAMPING...\n");
+
+  {
+  struct hwtstamp_config hwconfig;
+
+    int so_timestamping_flags = SOF_TIMESTAMPING_TX_HARDWARE
+                              | SOF_TIMESTAMPING_RX_HARDWARE
+                              | SOF_TIMESTAMPING_SYS_HARDWARE
+                              | SOF_TIMESTAMPING_RAW_HARDWARE;
+
+    netPath->eventSockIFR.ifr_data = (void *)&hwconfig;
+
+    memset(&hwconfig, 0, sizeof(&hwconfig));
+    hwconfig.tx_type = HWTSTAMP_TX_ON;
+    hwconfig.rx_filter = HWTSTAMP_FILTER_PTP_V2_L4_EVENT;
+
+    if (ioctl(netPath->eventSock, SIOCSHWTSTAMP, &netPath->eventSockIFR) < 0) {
+      if (errno == ERANGE) {
+        /* hardware time stamping not supported */
+        NOTIFY("SO_TIMESTAMPING: SIOCSHWTSTAMP mode of operation not supported\n");
+      } else {
+        NOTIFY("SO_TIMESTAMPING: SIOCSHWTSTAMP %s\n", strerror(errno));
+      }
+    } else {
+      /* Now enable the SO_TIMESTAMPING option on the event socket */
+      if (setsockopt(netPath->eventSock, SOL_SOCKET, SO_TIMESTAMPING,
+                     &so_timestamping_flags, sizeof(so_timestamping_flags)) < 0) {
+        /* Enabling SO_TIMESTAMPING on the socket shouldn't fail if the driver
+         * operation succeeded.
+         */
+        NOTIFY("SO_TIMESTAMPING: setsockopt error: %s", strerror(errno));
+        /* TODO should we carry on? */
+      } else {
+        NOTIFY("SO_TIMESTAMPING enabled\n");
+        ptpClock->tsMethod = TS_METHOD_SO_TIMESTAMPING;
+        return TRUE;
+      }
+    }
+  }
+
+#endif /* ifndef __sun */
+
+  /* Attempt IOCTL timestamping */
+  NOTIFY("trying IOCTL timestamping...\n");
+
+  {
+#ifdef __sun
+  struct sfxge_sock_ioctl req;
+#else
+  struct efx_sock_ioctl req;
+#endif
+    req.u.ts_init.flags = 0;
+    req.u.ts_init.tx_type = HWTSTAMP_TX_ON;
+    req.u.ts_init.rx_filter = HWTSTAMP_FILTER_PTP_V2_L4_EVENT;
+
+#ifdef __sun
+    req.cmd = SFXGE_TS_INIT;
+#else
+    req.cmd = EFX_TS_INIT;
+#endif
+
+    if(ptp_ioctl(netPath, &req) < 0) {
+      NOTIFY("could not activate SFC hardware rx/tx time stamping on %s, %s\n",
+              netPath->eventSockIFR.lifr_name, strerror(errno));
+    } else {
+      NOTIFY("SFC IOCTL timestamping enabled\n");
+      ptpClock->tsMethod = TS_METHOD_DRIVER_IOCTL;
+      return TRUE;
+    }
+  }
+
+  ERROR("failed to enable IOCTL hardware timestamping!\n");
+  return FALSE;
+}
+
+Boolean initTime(RunTimeOpts *rtOpts, PtpClock *ptpClock)
+{
+  Boolean rc;
+  
+  switch(rtOpts->time_mode) {
+  case TIME_SYSTEM:
+    ptpClock->tsMethod = TS_METHOD_SYSTEM;
+    return TRUE;
+    break;
+  case TIME_BOTH:
+    /* Prepare clock servo for controlling system time.
+     * TODO We can adjust the secondary servo rate now so this is no longer really true...
+     * "For the system->nic secondary servo, we reset the S, AP and AI parameters
+     * because the servo rate is fixed at 1 second, where as the filter parameters
+     * for the primary may by adjusted to compensate for message frequency and
+     * accuracy of measurements."
+     * Generally if noAdjust is set on the primary, set it on the secondary. The exception is
+     * when a master with NTP. In this case, the secondary is used to sync the NIC clock from
+     * the system clock so enable adjustment.
+     * The four scenarios are as follows:
+     *    Master + NTP:     system --> nic --> slave        (-G option)
+     *    Slave + NTP:      system --> nic  X  master       (-G option)
+     *    Master no NTP:    system <-- nic --> slave        (-W option)
+     *    Slave no NTP:     system <-- nic <-- master       (-g option)
+     */
+    timeBothClock = *ptpClock;
+    timeBothRtOpts = *rtOpts;
+    timeBothRtOpts.s = DEFAULT_DELAY_S;
+    timeBothRtOpts.ap = DEFAULT_AP;
+    timeBothRtOpts.ai = DEFAULT_AI;
+    timeBothClock.portState = PTP_SLAVE;
+
+    switch (rtOpts->master_slave_mode) {
+      case PTP_MODE_MASTER_WITH_NTP:
+        ptpClock->name = "[nic->slave]";
+        timeBothClock.name = "[system->nic]";
+        timeBothRtOpts.time_mode = TIME_NIC;
+        timeBothClock.nic_instead_of_system = TRUE;
+        timeBothRtOpts.noAdjust = DEFAULT_NO_ADJUST_CLOCK;
+        break;
+        
+      case PTP_MODE_MASTER_NO_NTP:
+        ptpClock->name = "[nic->slave]";
+        timeBothClock.name = "[nic->system]";
+        timeBothRtOpts.time_mode = TIME_SYSTEM;
+        timeBothClock.nic_instead_of_system = FALSE;
+        break;
+        
+      case PTP_MODE_SLAVE:
+        ptpClock->name = "[master->nic]";
+        timeBothClock.name = "[nic->system]";
+        timeBothRtOpts.time_mode = TIME_SYSTEM;
+        timeBothClock.nic_instead_of_system = FALSE;
+        break;
+        
+      default:
+        ERROR("Invalid value in switch %d\n", rtOpts->master_slave_mode);
+        return FALSE;
+    }
+
+    initClock(&timeBothRtOpts, &timeBothClock);
+    G_timeBothClock = &timeBothClock;
+    G_timeBothRtOpts = &timeBothRtOpts;
+
+    rc = selectNICTimeMode(rtOpts->time_mode, ptpClock);
+    if (rc && ((rtOpts->master_slave_mode != PTP_MODE_SLAVE) || rtOpts->noResetClock)) {
+      /* If we are in one or the master modes, set the NIC time once using the
+       * current system time. After this, the NIC time will free-run but at least
+       * we won't be shortly after the epoch. Note that we use timerNow rather
+       * than getTime to get the system time because getTime will return the NIC
+       * time in this mode.
+       */
+      TimeInternal time;
+      timerNow(&time);
+      setTime(&time, rtOpts->time_mode, ptpClock);
+      NOTIFY("NIC time set to system time: %d.%d\n", time.seconds, time.nanoseconds);
+    }
+    return rc;
+    break;
+  case TIME_NIC:
+    rc = selectNICTimeMode(rtOpts->time_mode, ptpClock);
+    if (rc && ((rtOpts->master_slave_mode != PTP_MODE_SLAVE) || rtOpts->noResetClock)) {
+      /* If we are in one or the master modes, set the NIC time once using the
+       * current system time. After this, the NIC time will free-run but at least
+       * we won't be shortly after the epoch. Note that we use timerNow rather
+       * than getTime to get the system time because getTime will return the NIC
+       * time in this mode.
+       */
+      TimeInternal time;
+      timerNow(&time);
+      setTime(&time, rtOpts->time_mode, ptpClock);
+      NOTIFY("NIC time set to system time: %d.%d\n", time.seconds, time.nanoseconds);
+    }
+    return rc;
+    break;
+  case TIME_SYSTEM_LINUX_HW:
+  case TIME_SYSTEM_LINUX_SW:
+    return selectNICTimeMode(rtOpts->time_mode, ptpClock);
+    break;
+  default:
+    ERROR("unsupported selection of time source\n");
+    return FALSE;
+    break;
+  }
+}
+
+void shutdownTime(PtpClock *ptpClock)
+{
+  NetPath *netPath = &ptpClock->netPath;
+
+  switch (ptpClock->tsMethod) {
+
+#ifndef __sun  /* Do not compile for the time being if __sun */
+    case TS_METHOD_SO_TIMESTAMPING:
+    {
+      int so_timestamping_flags = 0;
+
+      struct hwtstamp_config hwconfig;
+      netPath->eventSockIFR.ifr_data = (void *)&hwconfig;
+      memset(&hwconfig, 0, sizeof(&hwconfig));
+
+      hwconfig.tx_type = HWTSTAMP_TX_OFF;
+      hwconfig.rx_filter = HWTSTAMP_FILTER_NONE;
+      (void)ioctl(netPath->eventSock, SIOCSHWTSTAMP, &netPath->eventSockIFR);
+
+      (void)setsockopt(netPath->eventSock, SOL_SOCKET, SO_TIMESTAMPING,
+                       &so_timestamping_flags, sizeof(so_timestamping_flags));
+    }
+      break;
+#endif /* ifndef __sun */
+
+    case TS_METHOD_DRIVER_IOCTL:
+    {
+#ifdef __sun
+      struct sfxge_sock_ioctl req;
+      req.cmd = SFXGE_TS_INIT;
+#else
+      struct efx_sock_ioctl req;
+      req.cmd = EFX_TS_INIT;
+#endif
+      req.u.ts_init.flags = 0;
+      req.u.ts_init.tx_type = HWTSTAMP_TX_OFF;
+      req.u.ts_init.rx_filter = HWTSTAMP_FILTER_NONE;
+      (void)ptp_ioctl(netPath, &req);
+    }
+      break;
+
+    default:
+      break;
+  }
+}
+
+void getTime(TimeInternal *time, TimeMode timeMode, PtpClock *ptpClock)
+{
+  switch(timeMode)
+  {
+  case TIME_SYSTEM_LINUX_HW:
+  case TIME_SYSTEM_LINUX_SW:
+  case TIME_SYSTEM: {
+
+#if defined(__APPLE__) /* TODO Does OSX really not support clock_gettime()? */
+    struct timeval tv;
+
+    gettimeofday(&tv, 0);
+    time->seconds = tv.tv_sec;
+    time->nanoseconds = tv.tv_usec*1000;
+#else
+    struct timespec tv;
+    int err = clock_gettime(CLOCK_REALTIME, &tv);
+    if (err != 0) {
+      ERROR("error getting time %d\n", err);
+      return;
+    }
+    time->seconds = tv.tv_sec;
+    time->nanoseconds = tv.tv_nsec;
+#endif
+    break;
+  }
+  case TIME_BOTH:
+  case TIME_NIC: {
+    NetPath *netPath = &ptpClock->netPath;
+#ifdef __sun
+    struct sfxge_sock_ioctl req;
+#else
+    struct efx_sock_ioctl req;
+#endif
+
+    memset(&req, 0, sizeof(req));
+
+#ifdef __sun
+    req.cmd = SFXGE_TS_SETTIME;
+#else
+    req.cmd = EFX_TS_SETTIME;
+#endif
+    req.u.ts_settime.iswrite = 0;
+    if (ptp_ioctl(netPath, &req) < 0) {
+      ERROR("could not read SFC hardware time on %s: %s\n",
+            netPath->eventSockIFR.lifr_name, strerror(errno));
+      return;
+    }
+    time->seconds = req.u.ts_settime.ts.tv_sec;
+    time->nanoseconds = req.u.ts_settime.ts.tv_nsec;
+    break;
+  }
+  default:
+    ERROR("unsupported selection of time source\n");
+    break;
+  }
+}
+
+void setTime(TimeInternal *time, TimeMode timeMode, PtpClock *ptpClock)
+{
+  switch(timeMode)
+  {
+  case TIME_SYSTEM_LINUX_HW:
+  case TIME_SYSTEM_LINUX_SW:
+  case TIME_SYSTEM: {
+    WARNING("going to step the system clock to %ds %dns\n",
+            time->seconds, time->nanoseconds);
+#if defined(__APPLE__) /* TODO Does OSX really not support clock_settime()? */
+    struct timeval tv;
+    tv.tv_sec = time->seconds;
+    tv.tv_usec = time->nanoseconds/1000;
+    settimeofday(&tv, 0);
+#else
+    struct timespec tv;
+    tv.tv_sec = time->seconds;
+    tv.tv_nsec = time->nanoseconds;
+    int err = clock_settime(CLOCK_REALTIME, &tv);
+    if (err != 0) {
+      ERROR("error setting time %d\n", err);
+      return;
+    }
+#endif
+    WARNING("finished stepping the system clock to %ds %dns\n",
+            time->seconds, time->nanoseconds);
+    break;
+  }
+  case TIME_BOTH:
+  case TIME_NIC: {
+    NetPath *netPath = &ptpClock->netPath;
+#ifdef __sun
+    struct sfxge_sock_ioctl req;
+#else
+    struct efx_sock_ioctl req;
+#endif
+
+    TimeInternal currentTime, offset;
+
+    memset(&req, 0, sizeof(req));
+
+    NOTIFY("resetting NIC clock to %ds %dns\n", time->seconds, time->nanoseconds);
+    getTime(&currentTime, timeMode, ptpClock);
+    subTime(&offset, time, &currentTime);
+
+    req.u.ts_settime.iswrite = 1;
+    req.u.ts_settime.ts.tv_sec = offset.seconds;
+    req.u.ts_settime.ts.tv_nsec = offset.nanoseconds;
+#ifdef __sun
+    req.cmd = SFXGE_TS_SETTIME;
+#else
+    req.cmd = EFX_TS_SETTIME;
+#endif
+
+    NOTIFY("adding NIC offset %ld.%09d (%ld/%p)\n",
+           req.u.ts_settime.ts.tv_sec, req.u.ts_settime.ts.tv_nsec,
+           sizeof(req), &req);
+    if (ptp_ioctl(netPath, &req) < 0) {
+      ERROR("could not set SFC hardware time on %s: %s\n",
+            netPath->eventSockIFR.lifr_name, strerror(errno));
+    }
+    else
+    {
+      DBGV("new NIC time %ld.%09d\n",
+           req.u.ts_settime.ts.tv_sec,
+           req.u.ts_settime.ts.tv_nsec);
+    }
+    break;
+  }
+  default:
+    ERROR("unsupported selection of time source\n");
+    break;
+  }
+}
+
+
+void adjTime(LongDouble adj, TimeMode timeMode, PtpClock *ptpClock)
+{
+  switch(timeMode)
+  {
+  case TIME_SYSTEM_LINUX_HW:
+  case TIME_SYSTEM_LINUX_SW:
+  case TIME_SYSTEM: {
+    struct timex t;
+    static Boolean maxAdjValid;
+    static LongDouble maxAdj;
+    static LongDouble minTick, maxTick;
+    static LongDouble userHZ;
+    static LongDouble tickRes; /* USER_HZ * 1000 [ppb] */
+    LongDouble tickAdj;
+    LongDouble freqAdj;
+    long maxError;
+    int res;
+
+    if (!maxAdjValid) {
+        userHZ = (LongDouble)sysconf(_SC_CLK_TCK);
+        t.modes = 0;
+#ifdef __sun
+#warning Solaris - struct timex: t.constant is arbitrarily assigned to 15
+    t.constant = 15; /* need to be >0 but <30 */
+#endif
+        adjtimex(&t);
+        maxAdj = (LongDouble)t.tolerance / (((1<<16)+0.0)/1000.0);
+        tickRes = userHZ * 1000.0;
+        /* limits from the adjtimex command man page; could be determined via binary search */
+        minTick = (900000.0 - 1000000.0) / userHZ;
+        maxTick = (1100000.0 - 1000000.0) / userHZ;
+        maxAdjValid = TRUE;
+    }
+
+    /*
+     * The Linux man page for the adjtimex() system call does not
+     * describe limits for frequency. The more recent man page for
+     * the adjtimex command on RH5 does and says that
+     * -tolerance <= frequency <= tolerance
+     * which was confirmed by trying out values just outside that interval.
+     *
+     * Note that this contradicts the comments for struct timex which say
+     * that freq and tolerance have different units (scaled ppm vs ppm).
+     *
+     * We follow the actual implementation on Linux 2.6.22 and do the
+     * range check after scaling.
+     */
+
+     /* LDE 17082011 Set max error to stop adjtimex reported bad time */
+     t.modes = MOD_FREQUENCY|MOD_CLKB|MOD_MAXERROR;
+
+    /*
+     * 1 t.tick = 1 e-6 s * USER_HZ 1/s = 1 USER_HZ * 1000 ppb
+     *
+     * Large values of adj can be turned into t.tick adjustments:
+     * tickAdj t.tick = adj ppb / ( USER_HZ * 1000 ppb )
+     *
+     * Round this so that the error is as small is possible,
+     * because we need to fit that into t.freq.
+     */
+    freqAdj = adj;
+    tickAdj = 0;
+    if(freqAdj > maxAdj)
+    {
+      tickAdj = round((adj - maxAdj) / tickRes);
+      if(tickAdj > maxTick)
+        tickAdj = maxTick;
+      freqAdj = adj - tickAdj * tickRes;
+    }
+    else if(freqAdj < -maxAdj)
+    {
+      tickAdj = -round((-adj - maxAdj) / tickRes);
+      if(tickAdj < minTick)
+        tickAdj = minTick;
+      freqAdj = adj - tickAdj * tickRes;
+    }
+    if(freqAdj > maxAdj)
+      freqAdj = maxAdj;
+    else if(freqAdj < -maxAdj)
+      freqAdj = -maxAdj;
+
+    t.freq = (long)round(freqAdj * (((1 << 16) + 0.0) / 1000.0));
+#ifdef __sun
+#warning Solaris - struct timex: no field named tick
+#warning Solaris - struct timex: t.constant is arbitrarily assigned to 15
+    t.constant = 15; /* need to be >0 but <30 */
+#else
+    t.tick = (long)round(tickAdj + (1000000.0 / userHZ));
+#endif
+    ptpClock->frequency_adjustment = tickAdj * tickRes + freqAdj;
+
+    /* LDE 17082011 Set the max error to the current offset from master */
+    /* Saturate the max error at 2000 seconds. This is close the max value that */
+    /* fit in the max error field. */
+    if (ptpClock->offsetFromMaster.seconds > 2000) {
+      maxError = 0xffffffff;
+    } else {
+      maxError = ptpClock->offsetFromMaster.seconds * 1000000;
+      if (ptpClock->offsetFromMaster.nanoseconds > 0) {
+        maxError += ptpClock->offsetFromMaster.nanoseconds/1000;
+      } else {
+        maxError -= ptpClock->offsetFromMaster.nanoseconds/1000;
+      }
+    }
+    t.maxerror = maxError;
+
+#ifndef __sun
+    DBG("requested adj %Lf ppb => adjust system frequency by %ld scaled ppm (%Lf ppb) + %ld us/tick "
+        "(%Lf ppb) = adj %Lf ppb (freq limit %Lf/%Lf ppm, tick limit %Lf/%Lf us*USER_HZ)\n",
+        adj,
+        t.freq, freqAdj,
+        (long)(t.tick - 1000000.0 / userHZ), tickAdj * tickRes,
+        ptpClock->frequency_adjustment,
+        -maxAdj, maxAdj,
+        minTick, maxTick);
+#endif
+    res = adjtimex(&t);
+    switch (res) {
+    case -1:
+        ERROR("adjtimex(freq = %d) failed: %s\n",
+              t.freq, strerror(errno));
+        break;
+    case TIME_OK:
+        DBG("  -> TIME_OK\n");
+        break;
+    case TIME_INS:
+        ERROR("adjtimex -> insert leap second?!\n");
+        break;
+    case TIME_DEL:
+        ERROR("adjtimex -> delete leap second?!\n");
+        break;
+    case TIME_OOP:
+        ERROR("adjtimex -> leap second in progress?!\n");
+        break;
+    case TIME_WAIT:
+        ERROR("adjtimex -> leap second has occurred?!\n");
+        break;
+    case TIME_BAD:
+        ERROR("adjtimex -> time bad\n");
+        /* Clear the unsynchronised flag - we are synchronised */
+        t.modes = MOD_STATUS;
+        t.status &= ~STA_UNSYNC;
+        (void)adjtimex(&t);
+        INFO("clearing system time unsynchronised flag\n");
+        break;
+    default:
+        ERROR("adjtimex -> unknown result %d\n", res);
+        break;
+    }
+    break;
+  }
+  case TIME_BOTH:
+  case TIME_NIC: {
+    /* adjust NIC frequency */
+    NetPath *netPath = &ptpClock->netPath;
+#ifdef __sun
+    struct sfxge_sock_ioctl req;
+#else
+    struct efx_sock_ioctl req;
+#endif
+
+    memset(&req, 0, sizeof(req));
+    if (ptpClock->nic_instead_of_system) {
+      req.u.ts_adjtime.adjustment = (long long)round(-adj);
+      ptpClock->frequency_adjustment = -adj;
+    } else {
+      req.u.ts_adjtime.adjustment = (long long)round(adj);
+      ptpClock->frequency_adjustment = adj;
+    }
+    req.u.ts_adjtime.iswrite = 1;
+#ifdef __sun
+    req.cmd = SFXGE_TS_ADJTIME;
+#else
+    req.cmd = EFX_TS_ADJTIME;
+#endif
+    DBGV("adjust NIC frequency by %lld (%Lf) ppb\n",
+          req.u.ts_adjtime.adjustment, ptpClock->frequency_adjustment);
+    if (ptp_ioctl(netPath, &req) < 0) {
+      ERROR("could not modify SFC hardware frequency on %s: %s\n",
+            netPath->eventSockIFR.lifr_name, strerror(errno));
+    }
+    break;
+  }
+  default:
+    ERROR("unsupported selection of time source\n");
+    break;
+  }
+}
+
+void adjTimeOffset(TimeInternal *offset, TimeMode timeMode, PtpClock *ptpClock)
+{
+  switch(timeMode)
+  {
+    case TIME_BOTH:
+    case TIME_NIC: {
+      NetPath *netPath = &ptpClock->netPath;
+#ifdef __sun
+      struct sfxge_sock_ioctl req;
+#else
+      struct efx_sock_ioctl req;
+#endif
+
+      memset(&req, 0, sizeof(req));
+      req.u.ts_settime.iswrite = 1;
+      req.u.ts_settime.ts.tv_sec = offset->seconds;
+      req.u.ts_settime.ts.tv_nsec = offset->nanoseconds;
+#ifdef __sun
+      req.cmd = SFXGE_TS_SETTIME;
+#else
+      req.cmd = EFX_TS_SETTIME;
+#endif
+
+      /* invert the sign: if offset is positive, we need to substract it and vice versa;
+       * when in nic_instead_of_system the logic is already inverted
+       */
+      // TODO check that time is normalised at this point / use arith fns for all time ops
+      if (!ptpClock->nic_instead_of_system) {
+        req.u.ts_settime.ts.tv_sec *= -1;
+        req.u.ts_settime.ts.tv_nsec *= -1;
+      }
+
+      DBGV("adjust NIC time by offset %ld.%09d\n",
+          (UInteger32)req.u.ts_settime.ts.tv_sec, req.u.ts_settime.ts.tv_nsec);
+      if (ptp_ioctl(netPath, &req) < 0) {
+        ERROR("could not modify SFC hardware time on %s: %s\n",
+              ptpClock->netPath.eventSockIFR.lifr_name,
+              strerror(errno));
+      }
+      break;
+    }
+
+    default: {
+      TimeInternal timeTmp;
+
+      DBG2("Adjusting system time by offset %ld.%09d\n", offset->seconds, offset->nanoseconds);
+
+      getTime(&timeTmp, timeMode, ptpClock);
+      DBGV("**** Time was %ld.%09d\n", timeTmp.seconds, timeTmp.nanoseconds);
+      subTime(&timeTmp, &timeTmp, offset);
+      /* We don't allow the time to be set to before 1/1/1971 because this almost */
+      /* certainly means something has gone very wrong */
+      if (timeTmp.seconds < UTC_TIME_VALID_MINIMUM) {
+        DBG("**** Refusing to set system time to %ld.%09d\n", timeTmp.seconds, timeTmp.nanoseconds);
+      } else {
+        setTime(&timeTmp, timeMode, ptpClock);
+        DBG("System time adjusted to %ld.%09d\n", timeTmp.seconds, timeTmp.nanoseconds);
+      }
+    }
+  }
+}
+
+void adjTimeInsertLeapSecond(TimeMode timeMode, RunTimeOpts *rtOpts, PtpClock *ptpClock)
+{
+	if (rtOpts->noResetClock || rtOpts->resetClockStartupOnly)
+		return;
+	
+	switch(timeMode) {
+	case TIME_BOTH:
+	case TIME_NIC: 
+	case TIME_SYSTEM_LINUX_HW:
+	{
+		NetPath *netPath = &ptpClock->netPath;
+		LongDouble adj;
+#ifdef __sun
+		struct sfxge_sock_ioctl req;
+#else
+		struct efx_sock_ioctl req;
+#endif
+		memset(&req, 0, sizeof(req));
+#if defined(__sun)
+		req.cmd = SFXGE_TS_SETTIME;
+#else
+		req.cmd = EFX_TS_SETTIME;
+#endif 
+
+		req.u.ts_settime.iswrite = 1;
+		req.u.ts_settime.ts.tv_sec = -1;
+		req.u.ts_settime.ts.tv_nsec = 0;
+
+		DBGV("insert leap second in NIC time\n");
+		if (ptp_ioctl(netPath, &req) < 0) {
+			ERROR("could not modify SFC hardware time on %s: %s\n",
+			      ptpClock->netPath.eventSockIFR.lifr_name,
+			      strerror(errno));
+		}
+
+		/* Applying an offset resets the frequency adjustment to 0 (doh!)
+		 * If we are running in time mode both or nic, we need to set the
+		 * frequency adjustment back to the correct value immediately!
+		 */
+		if ((timeMode == TIME_BOTH) || (timeMode == TIME_NIC)) {
+			adj = (LongDouble)ptpClock->offsetFromMaster.nanoseconds / rtOpts->ap
+			    + ptpClock->observed_drift;
+
+			adjTime(-adj, timeMode, ptpClock);
+		}
+		break;
+	}
+
+	default:
+		INFO("No need to insert leap second for mode - handled by kernel\n");
+	}
+}
+
+void adjTimeDeleteLeapSecond(TimeMode timeMode, RunTimeOpts *rtOpts, PtpClock *ptpClock)
+{
+
+	if (rtOpts->noResetClock || rtOpts->resetClockStartupOnly)
+		return;
+	
+	switch(timeMode) {
+	case TIME_BOTH:
+	case TIME_NIC:
+	case TIME_SYSTEM_LINUX_HW:
+	{
+		NetPath *netPath = &ptpClock->netPath;
+		LongDouble adj;
+
+#ifdef __sun
+		struct sfxge_sock_ioctl req;
+
+		memset(&req, 0, sizeof(req));
+		req.cmd = SFXGE_TS_SETTIME;
+#else
+		struct efx_sock_ioctl req;
+
+		memset(&req, 0, sizeof(req));
+		req.cmd = EFX_TS_SETTIME;
+#endif
+
+		req.u.ts_settime.iswrite = 1;
+		req.u.ts_settime.ts.tv_sec = 1;
+		req.u.ts_settime.ts.tv_nsec = 0;
+
+		DBGV("delete leap second from NIC time\n");
+		if (ptp_ioctl(netPath, &req) < 0) {
+			ERROR("could not modify SFC hardware time on %s: %s\n",
+			      ptpClock->netPath.eventSockIFR.lifr_name,
+			      strerror(errno));
+		}
+
+		/* Applying an offset resets the frequency adjustment to 0 (doh!)
+		 * If we are running in time mode both or nic, we need to set the
+		 * frequency adjustment back to the correct value immediately!
+		 */
+		if ((timeMode == TIME_BOTH) || (timeMode == TIME_NIC)) {
+			adj = (LongDouble)ptpClock->offsetFromMaster.nanoseconds / rtOpts->ap
+			    + ptpClock->observed_drift;
+
+			adjTime(-adj, timeMode, ptpClock);
+		}
+		break;
+	}
+
+	default:
+		INFO("No need to insert leap second for mode - handled by kernel\n");
+	}
+}
+
+
+static void getTimeStamps(TimeMode timeMode, NetPath *netPath)
+{
+#ifdef __sun
+  struct sfxge_sock_ioctl req;
+#else
+  struct efx_sock_ioctl req;
+#endif
+
+  Boolean rawTime = (timeMode == TIME_BOTH) || (timeMode == TIME_NIC);
+
+  /* Repeatedly call the IOCTL until we have all the timestamps */
+  do {
+    memset(&req, 0, sizeof(req));
+#ifdef __sun
+    req.cmd = SFXGE_TS_READ;
+#else
+    req.cmd = EFX_TS_READ;
+#endif
+    if(ptp_ioctl(netPath, &req) < 0) {
+      ERROR("could not read SFC hardware time stamps on %s: %s\n",
+            netPath->eventSockIFR.lifr_name, strerror(errno));
+      return;
+    }
+
+    DBGV("rx %s, tx %s\n",
+         req.u.ts_read.rx_valid ? "valid" : "invalid",
+         req.u.ts_read.tx_valid ? "valid" : "invalid");
+
+    if(req.u.ts_read.rx_valid)
+    {
+      int newIndex;
+
+      if(nextFreeRecv == RECV_ARRAY_SIZE)
+      {
+        newIndex = 0;
+        nextFreeRecv = 1;
+        oldestRecv = 2;
+      }
+      else
+      {
+        newIndex = nextFreeRecv;
+        nextFreeRecv++;
+        if(oldestRecv && nextFreeRecv == oldestRecv)
+          ++oldestRecv;
+      }
+
+      if(oldestRecv >= RECV_ARRAY_SIZE)
+        oldestRecv = 0;
+
+      DBGV("new entry %d, oldest %d, next free %d\n", newIndex, oldestRecv, nextFreeRecv);
+
+      if (rawTime) {
+        lastRecvTimes[newIndex].recvTimeStamp.seconds = req.u.ts_read.rx_ts_hw.tv_sec;
+        lastRecvTimes[newIndex].recvTimeStamp.nanoseconds = req.u.ts_read.rx_ts_hw.tv_nsec;
+      } else {
+        lastRecvTimes[newIndex].recvTimeStamp.seconds = req.u.ts_read.rx_ts.tv_sec;
+        lastRecvTimes[newIndex].recvTimeStamp.nanoseconds = req.u.ts_read.rx_ts.tv_nsec;
+      }
+      lastRecvTimes[newIndex].sequenceId = ((uint16_t)req.u.ts_read.seqid[0] << 8)
+                                         | (uint16_t)req.u.ts_read.seqid[1];
+
+      /* Section 18.3.7 IEEE1588. Version 1 UUIDs are mapped into octets 2-7 of the clock
+       * ID. We don't compare the first two octets.
+       */
+      lastRecvTimes[newIndex].clockId[0] = 0;
+      lastRecvTimes[newIndex].clockId[1] = 0;
+      memcpy(lastRecvTimes[newIndex].clockId + sizeof(lastRecvTimes[newIndex].clockId) - sizeof(req.u.ts_read.uuid),
+             req.u.ts_read.uuid,
+             sizeof(req.u.ts_read.uuid));
+
+      DBGV("rx %d: time %d.%09u, sequence %u, uuid %02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx\n",
+           newIndex,
+           lastRecvTimes[newIndex].recvTimeStamp.seconds,
+           lastRecvTimes[newIndex].recvTimeStamp.nanoseconds,
+           lastRecvTimes[newIndex].sequenceId,
+           req.u.ts_read.uuid[0], req.u.ts_read.uuid[1], req.u.ts_read.uuid[2],
+           req.u.ts_read.uuid[3], req.u.ts_read.uuid[4], req.u.ts_read.uuid[5]);
+    }
+
+    if(req.u.ts_read.tx_valid)
+    {
+      if (rawTime) {
+        lastSendTime.seconds = req.u.ts_read.tx_ts_hw.tv_sec;
+        lastSendTime.nanoseconds = req.u.ts_read.tx_ts_hw.tv_nsec;
+      } else {
+        lastSendTime.seconds = req.u.ts_read.tx_ts.tv_sec;
+        lastSendTime.nanoseconds = req.u.ts_read.tx_ts.tv_nsec;
+      }
+
+      DBGV("tx time %d.%09d (%d.%09d)\n",
+           lastSendTime.seconds, lastSendTime.nanoseconds,
+           req.u.ts_read.tx_ts.tv_sec, req.u.ts_read.tx_ts.tv_nsec);
+    }
+  } while (req.u.ts_read.tx_valid || req.u.ts_read.rx_valid);
+}
+
+Boolean getSendTime(TimeInternal *sendTimeStamp,
+                    TimeMode timeMode, NetPath *netPath)
+{
+  /* check for new time stamps */
+  getTimeStamps(timeMode, netPath);
+
+  if(lastSendTime.seconds || lastSendTime.nanoseconds)
+  {
+    *sendTimeStamp = lastSendTime;
+    lastSendTime.seconds = 0;
+    lastSendTime.nanoseconds = 0;
+    return TRUE;
+  }
+  else
+    return FALSE;
+}
+
+/**
+ * helper function for getReceiveTime() which searches for time stamp
+ * in lastRecvTimes[leftIndex, rightIndex[
+ */
+static Boolean getReceiveTimeFromArray(TimeInternal *recvTimeStamp,
+                                       ClockIdentity clockId,
+                                       UInteger16 sequenceId,
+                                       int leftIndex, int rightIndex)
+{
+  int i;
+
+  DBGV("left idx %d, right idx %d\n", leftIndex, rightIndex);
+
+  //DBGV("sequence id %d, clock id %02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx\n",
+  //     sequenceId,
+  //     clockId[0], clockId[1], clockId[2], clockId[3],
+  //     clockId[4], clockId[5], clockId[6], clockId[7]);
+
+  for(i = leftIndex; i < rightIndex; i++)
+  {
+    //DBGV("rx index %d: time %d.%09d, sequence %u, clock id %02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx\n",
+    //     i,
+    //     lastRecvTimes[i].recvTimeStamp.seconds,
+    //     lastRecvTimes[i].recvTimeStamp.nanoseconds,
+    //     lastRecvTimes[i].sequenceId,
+    //     lastRecvTimes[i].clockId[0], lastRecvTimes[i].clockId[1],
+    //     lastRecvTimes[i].clockId[2], lastRecvTimes[i].clockId[3],
+    //     lastRecvTimes[i].clockId[4], lastRecvTimes[i].clockId[5],
+    //     lastRecvTimes[i].clockId[6], lastRecvTimes[i].clockId[7]);
+
+    if(!memcmp(lastRecvTimes[i].clockId + 2, clockId + 2, 6) &&
+       lastRecvTimes[i].sequenceId == sequenceId)
+    {
+      DBGV("found rx index %d: time %d.%09d, sequence %u, clock id %02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx\n",
+           i,
+           lastRecvTimes[i].recvTimeStamp.seconds,
+           lastRecvTimes[i].recvTimeStamp.nanoseconds,
+           lastRecvTimes[i].sequenceId,
+           lastRecvTimes[i].clockId[0], lastRecvTimes[i].clockId[1],
+           lastRecvTimes[i].clockId[2], lastRecvTimes[i].clockId[3],
+           lastRecvTimes[i].clockId[4], lastRecvTimes[i].clockId[5],
+           lastRecvTimes[i].clockId[6], lastRecvTimes[i].clockId[7]);
+
+      *recvTimeStamp = lastRecvTimes[i].recvTimeStamp;
+      // invalidate entry to prevent accidental reuse (happened when slaves were
+      // restarted quickly while the master still had their old sequence IDs in the array)
+      memset(&lastRecvTimes[i], 0, sizeof(lastRecvTimes[i]));
+      return TRUE;
+    }
+  }
+  return FALSE;
+}
+
+Boolean getReceiveTime(TimeInternal *recvTimeStamp,
+                       ClockIdentity clockId,
+                       UInteger16 sequenceId,
+                       TimeMode timeMode,
+                       NetPath *netPath)
+{
+  /* check for new time stamps */
+  getTimeStamps(timeMode, netPath);
+
+  if(oldestRecv <= nextFreeRecv)
+    return getReceiveTimeFromArray(recvTimeStamp, clockId, sequenceId, oldestRecv, nextFreeRecv);
+  else
+  {
+    if(getReceiveTimeFromArray(recvTimeStamp, clockId, sequenceId, oldestRecv, RECV_ARRAY_SIZE))
+      return TRUE;
+    else
+      return getReceiveTimeFromArray(recvTimeStamp, clockId, sequenceId, 0, nextFreeRecv);
+  }
+}
